import 'package:equatable/equatable.dart';

abstract class ChatUpdateEvent extends Equatable {
  final String chatId;

  ChatUpdateEvent(this.chatId);
}

class ChatUpdateRenameEvent extends ChatUpdateEvent {
  final String name;

  ChatUpdateRenameEvent(String chatId, this.name) : super(chatId);

  @override
  List<Object> get props => [chatId, name];
}

class ChatUpdateKickEvent extends ChatUpdateEvent {
  final String userId;

  ChatUpdateKickEvent(String chatId, this.userId) : super(chatId);
  @override
  List<Object> get props => [chatId, userId];
}

class ChatUpdateAddListEvent extends ChatUpdateEvent {
  final List<String> users;

  ChatUpdateAddListEvent(String chatId, this.users) : super(chatId);

  @override
  List<Object> get props => [chatId, users];
}

class ChatUpdateAdminEvent extends ChatUpdateEvent {
  final String admin;
  ChatUpdateAdminEvent(String chatId, this.admin) : super(chatId);

  @override
  List<Object> get props => [chatId, admin];
}
